searchData={"items":[{"type":"module","title":"Ease","doc":"Provides a number of popular easing functions.\n\nUseful if you're doing animation or some sort of motion.\n\nSee [easings.net](http://easings.net) for nice graphs of each function.","ref":"Ease.html"},{"type":"function","title":"Ease.ease_in_circular/4","doc":"Circular ease-in.\n\nAcceleration from zero velocity.","ref":"Ease.html#ease_in_circular/4"},{"type":"function","title":"Examples - Ease.ease_in_circular/4","doc":"iex> Ease.map(1..10, :ease_in_circular)\n    ...> |> Enum.map(&Float.round(&1, 3))\n    [1.0, 1.056, 1.225, 1.515, 1.938, 2.517, 3.292, 4.343, 5.877, 10.0]","ref":"Ease.html#ease_in_circular/4-examples"},{"type":"function","title":"Ease.ease_in_cubic/4","doc":"Cubic ease-in.\n\nAcceleration from zero velocity.","ref":"Ease.html#ease_in_cubic/4"},{"type":"function","title":"Examples - Ease.ease_in_cubic/4","doc":"iex> Ease.map(1..10, :ease_in_cubic)\n    ...> |> Enum.map(&Float.round(&1, 3))\n    [1.0, 1.012, 1.099, 1.333, 1.79, 2.543, 3.667, 5.235, 7.321, 10.0]","ref":"Ease.html#ease_in_cubic/4-examples"},{"type":"function","title":"Ease.ease_in_expo/4","doc":"Exponential ease-in.\n\nAcceleration from zero velocity.","ref":"Ease.html#ease_in_expo/4"},{"type":"function","title":"Examples - Ease.ease_in_expo/4","doc":"iex> Ease.map(1..10, :ease_in_expo)\n    ...> |> Enum.map(&Float.round(&1, 3))\n    [1.009, 1.019, 1.041, 1.089, 1.191, 1.413, 1.893, 2.929, 5.166, 10.0]","ref":"Ease.html#ease_in_expo/4-examples"},{"type":"function","title":"Ease.ease_in_out_circular/4","doc":"Circular ease-in-out.\n\nAccelleration from zero velocity to half-way, then decelleration to zero velocity.","ref":"Ease.html#ease_in_out_circular/4"},{"type":"function","title":"Examples - Ease.ease_in_out_circular/4","doc":"iex> Ease.map(1..10, :ease_in_out_circular)\n    ...> |> Enum.map(&Float.round(&1, 3))\n    [1.0, 1.113, 1.469, 2.146, 3.438, 7.562, 8.854, 9.531, 9.887, 10.0]","ref":"Ease.html#ease_in_out_circular/4-examples"},{"type":"function","title":"Ease.ease_in_out_cubic/4","doc":"Cubic ease-in-out.\n\nAccelleration from zero velocity to half-way, then decelleration to zero velocity.","ref":"Ease.html#ease_in_out_cubic/4"},{"type":"function","title":"Examples - Ease.ease_in_out_cubic/4","doc":"iex> Ease.map(1..10, :ease_in_out_cubic)\n    ...> |> Enum.map(&Float.round(&1, 3))\n    [1.0, 1.049, 1.395, 2.333, 4.16, 6.84, 8.667, 9.605, 9.951, 10.0]","ref":"Ease.html#ease_in_out_cubic/4-examples"},{"type":"function","title":"Ease.ease_in_out_expo/4","doc":"Exponential ease-in-out.\n\nAccelleration from zero velocity to half-way, then decelleration to zero velocity.","ref":"Ease.html#ease_in_out_expo/4"},{"type":"function","title":"Examples - Ease.ease_in_out_expo/4","doc":"iex> Ease.map(1..10, :ease_in_out_expo)\n    ...> |> Enum.map(&Float.round(&1, 3))\n    [1.004, 1.021, 1.096, 1.446, 3.083, 7.917, 9.554, 9.904, 9.979, 9.996]","ref":"Ease.html#ease_in_out_expo/4-examples"},{"type":"function","title":"Ease.ease_in_out_quad/4","doc":"Quadratic ease-in-out.\n\nAccelleration from zero velocity to half-way, then decelleration to zero velocity.","ref":"Ease.html#ease_in_out_quad/4"},{"type":"function","title":"Examples - Ease.ease_in_out_quad/4","doc":"iex> Ease.map(1..10, :ease_in_out_quad)\n    ...> |> Enum.map(&Float.round(&1, 3))\n    [1.0, 1.222, 1.889, 3.0, 4.556, 6.444, 8.0, 9.111, 9.778, 10.0]","ref":"Ease.html#ease_in_out_quad/4-examples"},{"type":"function","title":"Ease.ease_in_out_quartic/4","doc":"Quartic ease-in-out.\n\nAccelleration from zero velocity to half-way, then decelleration to zero velocity.","ref":"Ease.html#ease_in_out_quartic/4"},{"type":"function","title":"Examples - Ease.ease_in_out_quartic/4","doc":"iex> Ease.map(1..10, :ease_in_out_quartic)\n    ...> |> Enum.map(&Float.round(&1, 3))\n    [1.0, 1.011, 1.176, 1.889, 3.809, 7.191, 9.111, 9.824, 9.989, 10.0]","ref":"Ease.html#ease_in_out_quartic/4-examples"},{"type":"function","title":"Ease.ease_in_out_quintic/4","doc":"Quintic ease-in-out.\n\nAccelleration from zero velocity to half-way, then decelleration to zero velocity.","ref":"Ease.html#ease_in_out_quintic/4"},{"type":"function","title":"Examples - Ease.ease_in_out_quintic/4","doc":"iex> Ease.map(1..10, :ease_in_out_quintic)\n    ...> |> Enum.map(&Float.round(&1, 3))\n    [1.0, 1.002, 1.078, 1.593, 3.497, 7.503, 9.407, 9.922, 9.998, 10.0]","ref":"Ease.html#ease_in_out_quintic/4-examples"},{"type":"function","title":"Ease.ease_in_out_sine/4","doc":"Sinusoidal ease-in-out.\n\nAccelleration from zero velocity to half-way, then decelleration to zero velocity.","ref":"Ease.html#ease_in_out_sine/4"},{"type":"function","title":"Examples - Ease.ease_in_out_sine/4","doc":"iex> Ease.map(1..10, :ease_in_out_sine)\n    ...> |> Enum.map(&Float.round(&1, 3))\n    [1.0, 1.271, 2.053, 3.25, 4.719, 6.281, 7.75, 8.947, 9.729, 10.0]","ref":"Ease.html#ease_in_out_sine/4-examples"},{"type":"function","title":"Ease.ease_in_quad/4","doc":"Quadratic ease-in.\n\nAcceleration from zero velocity.","ref":"Ease.html#ease_in_quad/4"},{"type":"function","title":"Examples - Ease.ease_in_quad/4","doc":"iex> Ease.map(1..10, :ease_in_quad)\n    ...> |> Enum.map(&Float.round(&1, 3))\n    [1.0, 1.111, 1.444, 2.0, 2.778, 3.778, 5.0, 6.444, 8.111, 10.0]","ref":"Ease.html#ease_in_quad/4-examples"},{"type":"function","title":"Ease.ease_in_quartic/4","doc":"Quartic ease-in.\n\nAcceleration from zero velocity.","ref":"Ease.html#ease_in_quartic/4"},{"type":"function","title":"Examples - Ease.ease_in_quartic/4","doc":"iex> Ease.map(1..10, :ease_in_quartic)\n    ...> |> Enum.map(&Float.round(&1, 3))\n    [1.0, 1.001, 1.022, 1.111, 1.351, 1.857, 2.778, 4.294, 6.619, 10.0]","ref":"Ease.html#ease_in_quartic/4-examples"},{"type":"function","title":"Ease.ease_in_quintic/4","doc":"Quintic ease-in.\n\nAcceleration from zero velocity.","ref":"Ease.html#ease_in_quintic/4"},{"type":"function","title":"Examples - Ease.ease_in_quintic/4","doc":"iex> Ease.map(1..10, :ease_in_quintic)\n    ...> |> Enum.map(&Float.round(&1, 3))\n    [1.0, 1.0, 1.005, 1.037, 1.156, 1.476, 2.185, 3.562, 5.994, 10.0]","ref":"Ease.html#ease_in_quintic/4-examples"},{"type":"function","title":"Ease.ease_in_sine/4","doc":"Sinusoidal ease-in.\n\nAcceleration from zero velocity.","ref":"Ease.html#ease_in_sine/4"},{"type":"function","title":"Examples - Ease.ease_in_sine/4","doc":"iex> Ease.map(1..10, :ease_in_sine)\n    ...> |> Enum.map(&Float.round(&1, 3))\n    [1.0, 1.137, 1.543, 2.206, 3.106, 4.215, 5.5, 6.922, 8.437, 10.0]","ref":"Ease.html#ease_in_sine/4-examples"},{"type":"function","title":"Ease.ease_out_circular/4","doc":"Circular ease-out.\n\nDecelleration to zero velocity.","ref":"Ease.html#ease_out_circular/4"},{"type":"function","title":"Examples - Ease.ease_out_circular/4","doc":"iex> Ease.map(1..10, :ease_out_circular)\n    ...> |> Enum.map(&Float.round(&1, 3))\n    [1.0, 5.123, 6.657, 7.708, 8.483, 9.062, 9.485, 9.775, 9.944, 10.0]","ref":"Ease.html#ease_out_circular/4-examples"},{"type":"function","title":"Ease.ease_out_cubic/4","doc":"Cubic ease-out.\n\nDecelleration to zero velocity.","ref":"Ease.html#ease_out_cubic/4"},{"type":"function","title":"Examples - Ease.ease_out_cubic/4","doc":"iex> Ease.map(1..10, :ease_out_cubic)\n    ...> |> Enum.map(&Float.round(&1, 3))\n    [1.0, 3.679, 5.765, 7.333, 8.457, 9.21, 9.667, 9.901, 9.988, 10.0]","ref":"Ease.html#ease_out_cubic/4-examples"},{"type":"function","title":"Ease.ease_out_expo/4","doc":"Exponential ease-out.\n\nDecelleration to zero velocity.","ref":"Ease.html#ease_out_expo/4"},{"type":"function","title":"Examples - Ease.ease_out_expo/4","doc":"iex> Ease.map(1..10, :ease_out_expo)\n    ...> |> Enum.map(&Float.round(&1, 3))\n    [1.0, 5.834, 8.071, 9.107, 9.587, 9.809, 9.911, 9.959, 9.981, 9.991]","ref":"Ease.html#ease_out_expo/4-examples"},{"type":"function","title":"Ease.ease_out_quad/4","doc":"Quadratic ease-out.\n\nDecelleration to zero velocity.","ref":"Ease.html#ease_out_quad/4"},{"type":"function","title":"Examples - Ease.ease_out_quad/4","doc":"iex> Ease.map(1..10, :ease_out_quad)\n    ...> |> Enum.map(&Float.round(&1, 3))\n    [1.0, 0.889, 0.556, 0.0, -0.778, -1.778, -3.0, -4.444, -6.111, -8.0]","ref":"Ease.html#ease_out_quad/4-examples"},{"type":"function","title":"Ease.ease_out_quartic/4","doc":"Quartic ease-out.\n\nDecelleration to zero velocity.","ref":"Ease.html#ease_out_quartic/4"},{"type":"function","title":"Examples - Ease.ease_out_quartic/4","doc":"iex> Ease.map(1..10, :ease_out_quartic)\n    ...> |> Enum.map(&Float.round(&1, 3))\n    [1.0, 4.381, 6.706, 8.222, 9.143, 9.649, 9.889, 9.978, 9.999, 10.0]","ref":"Ease.html#ease_out_quartic/4-examples"},{"type":"function","title":"Ease.ease_out_quintic/4","doc":"Quintic ease-out.\n\nDecelleration to zero velocity.","ref":"Ease.html#ease_out_quintic/4"},{"type":"function","title":"Examples - Ease.ease_out_quintic/4","doc":"iex> Ease.map(1..10, :ease_out_quintic)\n    ...> |> Enum.map(&Float.round(&1, 3))\n    [1.0, 5.006, 7.438, 8.815, 9.524, 9.844, 9.963, 9.995, 10.0, 10.0]","ref":"Ease.html#ease_out_quintic/4-examples"},{"type":"function","title":"Ease.ease_out_sine/4","doc":"Sinusoidal ease-out.\n\nDecelleration to zero velocity.","ref":"Ease.html#ease_out_sine/4"},{"type":"function","title":"Examples - Ease.ease_out_sine/4","doc":"iex> Ease.map(1..10, :ease_out_sine)\n    ...> |> Enum.map(&Float.round(&1, 3))\n    [1.0, 2.563, 4.078, 5.5, 6.785, 7.894, 8.794, 9.457, 9.863, 10.0]","ref":"Ease.html#ease_out_sine/4-examples"},{"type":"function","title":"Ease.linear/4","doc":"No easing.\n\nConstant velocity with no accelleration.","ref":"Ease.html#linear/4"},{"type":"function","title":"Examples - Ease.linear/4","doc":"iex> Ease.map(1..10, :linear)\n    [1.0, 2.0, 3.0, 4.0, 5.0, 6.0, 7.0, 8.0, 9.0, 10.0]","ref":"Ease.html#linear/4-examples"},{"type":"function","title":"Ease.map/2","doc":"Map an enumerable into it's eased version.\n\nThis is a pretty useless function, I've implemented it mainly for\ndocumentation purposes.","ref":"Ease.html#map/2"},{"type":"function","title":"Examples - Ease.map/2","doc":"iex> Ease.map(1..10, :linear)\n    [1.0, 2.0, 3.0, 4.0, 5.0, 6.0, 7.0, 8.0, 9.0, 10.0]","ref":"Ease.html#map/2-examples"},{"type":"type","title":"Ease.easing_function/0","doc":"","ref":"Ease.html#t:easing_function/0"},{"type":"extras","title":"Ease","doc":"# Ease\n\n[![Build Status](https://drone.harton.dev/api/badges/james/ease/status.svg?ref=refs/heads/main)](https://drone.harton.dev/james/ease)\n[![Hex.pm](https://img.shields.io/hexpm/v/ease.svg)](https://hex.pm/packages/ease)\n[![Hippocratic License HL3-FULL](https://img.shields.io/static/v1?label=Hippocratic%20License&message=HL3-FULL&labelColor=5e2751&color=bc8c3d)](https://firstdonoharm.dev/version/3/0/full.html)\n\nA generic implementation of standard easing functions for use in animation or\nrobotics.\n\nFor examples of \"standard\" easing algorithms (in this case used in CSS\nanimations) take a look at [easings.net](http://easings.net)","ref":"readme.html"},{"type":"extras","title":"Installation - Ease","doc":"Ease is [available in Hex](https://hex.pm/packages/ease), the package can be installed\nby adding `ease` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:ease, \"~> 1.0.1\"}\n  ]\nend\n```\n\nDocumentation for the latest release can be found on\n[HexDocs](https://hexdocs.pm/ease) and for the `main` branch on\n[docs.harton.nz](https://docs.harton.nz/james/ease).","ref":"readme.html#installation"},{"type":"extras","title":"Usage - Ease","doc":"You can use an easing function directly from within your own loop, provided\nthat you can supply the four arguments needed;\n\n- `current_time` - the elapsed \"time\" in the loop, ie if your `duration` is\n  ten, and you want to find the position for half way through the duration\n  then you set it to `5`. Units are arbitrary (steps, ms, whatever).\n- `start_value` - the initial value or position at `current_time` of zero.\n- `change_in_value`- how much the `start_value` should be changed by the end\n  of the animation, ie the expected final value minus the `start_value`.\n- `duration` - the duration of the animation, in the same units as `current_time`.\n\nGiven a quadratic ease-in of `1..10`, over 1 unit of time, where would we be\nwhen half-way through:\n\n    iex> Ease.ease_in_quad(0.5, 1, 10, 1)\n    3.25\n\nPlot the `{x, y}` positions for a circular ease-in:\n\n    iex> ys = 1..10\n    ...> xs = Ease.map(ys, :ease_in_circular)\n    ...> Enum.zip(xs, ys)\n    [{1.0, 1}, {1.0557280900008417, 2}, {1.2250356126078779, 3},\n     {1.5147186257614298, 4}, {1.9377422517014504, 5}, {2.5166852264521173, 6},\n     {3.291796067500631, 7}, {4.34314575050762, 8}, {5.876894374382339, 9},\n     {10.0, 10}]","ref":"readme.html#usage"},{"type":"extras","title":"Github Mirror - Ease","doc":"This repository is mirrored [on Github](https://github.com/jimsynz/ease)\nfrom it's primary location [on my Forejo instance](https://harton.dev/james/ease).\nFeel free to raise issues and open PRs on Github.","ref":"readme.html#github-mirror"},{"type":"extras","title":"License - Ease","doc":"This software is licensed under the terms of the\n[HL3-FULL](https://firstdonoharm.dev), see the `LICENSE.md` file included with\nthis package for the terms.\n\nThis license actively proscribes this software being used by and for some\nindustries, countries and activities. If your usage of this software doesn't\ncomply with the terms of this license, then [contact me](mailto:james@harton.nz)\nwith the details of your use-case to organise the purchase of a license - the\ncost of which may include a donation to a suitable charity or NGO.","ref":"readme.html#license"},{"type":"extras","title":"Change Log","doc":"# Change Log\n\nAll notable changes to this project will be documented in this file.\nSee [Conventional Commits](Https://conventionalcommits.org) for commit guidelines.\n\n<!-- changelog -->\n\n## [v1.0.1](https://harton.dev/james/ease/compare/v1.0.0...v1.0.1) (2024-02-22)\n\n\n\n\n## [v1.0.0](https://harton.dev/james/ease/compare/v0.2.0...v1.0.0) (2023-01-16)\n\n#","ref":"changelog.html"},{"type":"extras","title":"Breaking Changes: - Change Log","doc":"- Relicense to HL3-FULL.\n\n## [v0.2.0](https://harton.dev/james/ease/compare/v0.2.0...v0.2.0) (2020-12-28)","ref":"changelog.html#breaking-changes"}],"content_type":"text/markdown"}